Subject: Re: git diff shows twice “\ No newline at end of file” - no need for repetition

From: Junio C Hamano <[email-masked]>
Date: Wed, 13 Aug 2025 07:51:09 -0700

Phillip Wood <[email-masked]> writes:

> On 13/08/2025 08:20, Дилян Палаузов wrote:
>> Hello,
>> when a file, which does not end in a new line, is modified, git diff
>> shows twice the text “\ No newline at end of file”. As this piece
>> of the file is not modified, I think git diff should print it once.
>> In the example below the first “\ No newline at end of file”
>> should be skipped.
>
> The "\ No newline at end of file" applies to the line that precedes
> it. Removing the first instance in your example would mean the the
> newline at the end of the file had been removed when the line was
> changed. The output of git matches what GNU diff shows for incomplete
> lines.
>
> Thanks

Thanks for a concise and accurate diagnosis.  It is unfortunate that
we cannot point at POSIX X-<.